import shapefile

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

x = -50
y = 50
a = -100
b = 20
c = 80
d = 100

points = [[[[x,x],[x,y],[y,y],[y,x],[x,x]]], [[[a,a],[a,b],[b,b],[b,a],[a,a]]], [[[c,c],[c,d],[d,d],[d,c],[c,c]]]]

def write_shp (points,filepath):
# Take points list and write to .shp. Points seem to need two []s around (?).
	# Begin instance of Writer class.
	w = shapefile.Writer()
	# Ensure shape and records balance.
	w.autoBalance = 1

	print len(points)
	
	for i in range(len(points)):
		# Start and stop point are the same to close shape.
		w.poly(parts=points[i])
		w.field('%d_FLD' % i,'C','40')
#		w.record('%d' % i, 'Square')

	w.save(filepath)
	return False

filepath = "polygon"
write_shp (points,filepath)
