#imports the library shapefile to allow the shapefile operations

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

import shapefile

readPath = "p.shp"
writePath = "w.shp"




line = "Point(2) = {1,2,3,4}"

tokens = parsePoint(line)

for t in tokens:
	print t + " "


"""
read = open(readPath,"r")
write = shapefile.Editor(shapefile=writePath) 

while 1 : 


	line = f.readline()
	if not line :
		print 'end of file'
		break
	points = parsePoint(line)
	writePointToFile(points,write)

	print 'written to file  --> '
	print line

read.close()
write.close()

"""

def writePointToFile(points,fileStream):
	f = shapefile.Editor(shapefile=fp)
	fileStream.point(float(points[0]),float(points[1]),float(points[2]),float(points[3]))
	fileStream.record("Appended","Point")
	fileStream.save(fp)
	return


def parsePoint(line):
	if 'Point' in line :
		tokens = line.split('= {',2)
	  points = tokens[1].split(', ',4)
		points[3] = points[3][0:len(points[3])-3]
		return points
